<?php

/**
*
* @copyright (c) 2012 Laf Innovative, Ltd.
* @license http://www.opensource.org/licenses/mit-license.php MIT License
* 
*/

require_once("database.php");
require_once("functions.php");

set_time_limit(cfg("admin_set_time_limit"));
$startTime = array_sum(explode(" ", microtime()));

if (!isset($_REQUEST['adp'])) {
    $adp = "main";
} else {
    $adp = $_REQUEST['adp'];
}

if (!isset($_REQUEST['action'])) {
    $action = "main";
} else {
    $action = $_REQUEST['action'];
}

if (!isset($_REQUEST['num'])) {
    $num = 0;
} else {
    $num = $_REQUEST['num'];
}

if (!isset($_REQUEST['orderby'])) {
    $orderby = "url";
} else {
    $orderby = $_REQUEST['orderby'];
}

if (!isset($_REQUEST['how'])) {
    $how = "ASC";
} else {
    $how = $_REQUEST['how'];
}

if (isset($_REQUEST['url'])) {
    $url = $_REQUEST['url'];
} else {
    $url = "";
}

if (isset($_REQUEST['what'])) {
    $what = $_REQUEST['what'];
}

if (isset($_REQUEST['id'])) {
    $id = $_REQUEST['id'];
}

if (isset($_REQUEST['page'])) {
    $page = $_REQUEST['page'];
} else {
    $page = 1;
}

if (isset($_REQUEST['path'])) {
    $path = $_REQUEST['path'];
} else {
    $path = "";
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml" xml:lang="en" lang="en"> 
<head> 
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Astanda Directory Project v.<?php echo ADP_VER; if (ADP_DEMO == "1") { echo " -DEMO-"; } ?></title>
<meta name="robots" content="noindex,nofollow" />
<style type="text/css">
body{
margin:0;
padding:0;
background-color:#F4F4F4;
font-family:Verdana, Helvetica, sans-serif;
font-size:1.0em;
}
a:link, a:visited{
text-decoration:none
}
a:hover{
text-decoration:underline
}
.strong{
font-weight:bold;
}
#page-container{
margin:0 auto;
padding:5px;
width:95%;
}
#header{
padding:5px;
background:#ffffff;
border:1px dotted #008000;
margin:0 0 5px 0;
}
#header h1{
text-align:center;
margin:0;
padding:10px 0 10px;
font-size:1.4em;
color:#008000;
/* text-indent:-9000px; */
}
#navigation{
text-align:center;
margin:0 0 5px 0;
font-size:0.8em;
padding:5px;
background:#ffffff;
border:1px dotted #008000;
}
#functions{
text-align:center;
margin:0 0 5px 0;
padding:5px;
background:#ffffff;
border:1px dotted #008000;
}
#content{
margin:0 0 5px 0;
font-size:0.8em;
padding:5px;
background:#ffffff;
border:1px dotted #008000;
}
#footer{
padding:5px;
background:#ffffff;
border:1px dotted #008000;
text-align:center;
font-size:0.6em;
}
#update_notification{
font-size:0.6em;
text-align:right;
}
</style>
</head>
<body>
<div id="page-container">

	<div id="header">
		<div id="logo"><h1>Astanda Directory Project</h1></div>

<?php

	if(adp_version_check()){

?>

		<div id="update_notification">
			ADP v<?php echo $GLOBALS['version_info']['latest_version']; ?> Available! <a href="<?php echo $GLOBALS['version_info']['download_url']; ?>">Download Now &raquo;</a>
		</div>

<?php

	}

?>

	</div>

	<div id="navigation">
		<a href="index.php?adp=main">Main</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=categories">Categories</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=links">Links</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=pages">Pages</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=import">Import</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=banned">Banned</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=config">Config</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=build">Build</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=log">Log</a>
	</div>

	<div id="content">

<?php

switch ($adp){

	case "main":
		require_once("main.php");
	break;

	case "links":
		require_once("links.php");
	break;

	case "pages":
		require_once("pages.php");
	break;

	case "import":
		require_once("import.php");
	break;

	case "banned":
		require_once("banned.php");
	break;

	case "categories":
		require_once("categories.php");
	break;

	case "build":
		require_once("build.php");
	break;

	case "config":
		require_once("config.php");
	break;

	case "build":
		require_once("build.php");
	break;

	case "log":
		require_once("log.php");
	break;

}

?>

	</div>

	<div id="footer">
		&copy; <?php echo date('Y'); ?> <a href="http://lafinnovative.com" onclick="window.open(this.href); return false;">Laf innovative, Ltd</a>. All Rights Reserved.<br />
		Powered by <a href="http://lafinnovative.com/projects/astanda-directory-project/">ADP</a> v<?php echo ADP_VER; ?><br />
		<!-- <?php echo round((array_sum(explode(" ", microtime())) - $startTime), 4) * 1000 ?>MS -->
	</div>

</div>
</body>
</html>