<?php

/**
*
* @copyright (c) 2011 Laf Innovative, Ltd.
* @license http://www.opensource.org/licenses/mit-license.php MIT License
* 
*/

define('ADP_INSTALL', true);

require_once('functions.php');

if(file_exists("database.php")){

	if(isset($_GET['action']) && $_GET['action'] == 'update'){

		$updater = _adp_updater();

	}
	else{

		$checker = _adp_updater_quick_check();

	}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>ADP Updater</title>
<!-- meta tags -->
<meta name="robots" content="NOINDEX,FOLLOW" />
<!-- style -->
<style type="text/css">
body{
font-family:Arial, Helvetica, sans-serif;
font-size:1.0em;
}
div#wrap{
font-size:0.8em;
margin:15px auto 0 auto;
width:500px;
}
div#information{
margin:15px;
padding:5px;
border:1px dotted #990000;
}
div#footer{
font-size:0.8em;
text-align:center;
border-top:1px solid #000;
padding:5px;
}
h1{
text-align:center;
}
.strong{
font-weight:bold;
}
.green{
color:#339900;
}
.red{
color:#990000;
}
.right{
text-align:right;
}
</style>
</head>
<body>
<div id="wrap">
<?php

	if(isset($checker)){

		if($checker['status'] === true){

?>

	<h1>Database Update Necessary</h1>
	<p>Please <span class="strong">backup</span> your database <span class="strong">prior</span> to running this update. Once you have done so, click &quot;Update Now&quot;.</p>
	<p class="right"><a href="./update.php?action=update">Update Now &raquo;</a></p>

<?php

		}
		else{

?>

	<h1>No Database Update Necessary</h1>
	<p>Your database is already at ADP v<?php echo ADP_VER; ?>.</p>
	<p class="strong">Please remove the following files:</p>
	<ol>
		<li>./admin/install.php</li>
		<li>./admin/update.php</li>
		<li>./INSTALL.txt</li>
	</ol>


<?php

		}

	}

	if(isset($updater)){

		if($updater['status'] === true){

?>

	<h1 class="green">Successful Database Update</h1>
	<p>Your database has been updated to ADP v<?php echo ADP_VER; ?>.</p>
	<p class="strong">Please remove the following files:</p>
	<ol>
		<li>./admin/install.php</li>
		<li>./admin/update.php</li>
		<li>./INSTALL.txt</li>
	</ol>
	<p class="strong">It is important that you check your ADP configuration!</p>

<?php

		}
		else{

?>

	<h1 class="red">Unsuccessful Update</h1>
	<p>Here is a specific error:</p>
	<div id="information"><?php echo $updater['information'] ?></div>

<?php

		}

	}

?>
<div id="footer">&copy; <?php echo date('Y'); ?> <a href="http://lafinnovative.com">Laf Innovative, Ltd.</a>. All Rights Reserved.</div>
</div>
</body>
</html>

<?php

}
else{

	//ADP is probably not installed if the database.php file does not exist.
	//So we will redirect to the install page.
	header('Location:./install.php');
	exit();

}

function _adp_updater_quick_check(){

	require_once("database.php");

	//Lets get the currently installed version of ADP (for older installs)
	$r = mysql_query('SELECT version FROM config');

	if(@mysql_num_rows($r)){

		$version = mysql_fetch_assoc($r);

		$version = $version['version'];

	}
	else{

		//Lets get the currently installed version of ADP (for newer)
		$r = mysql_query('SELECT option_value FROM config WHERE option_name = "version" LIMIT 1');

		if(@mysql_num_rows($r)){

			$version = mysql_fetch_assoc($r);

			$version = $version['option_value'];

		}

	}

	if($version === 0 || version_compare(ADP_VER, $version, '>')){

		return array('status'=>true);

	}

	return array('status'=>false);

}

function _adp_updater(){

	require_once("database.php");

	if(mysql_num_rows(mysql_query('SHOW TABLES FROM ' . mysql_real_escape_string($database) . ' LIKE "config"'))){

		//Lets get the currently installed version of ADP (for older installs)
		$r = mysql_query('SELECT version FROM config');

		if(@mysql_num_rows($r)){

			$version = mysql_fetch_assoc($r);

			$version = $version['version'];

		}
		else{

			//Lets get the currently installed version of ADP (for newer)
			$r = mysql_query('SELECT option_value FROM config WHERE option_name = "version" LIMIT 1');

			if(@mysql_num_rows($r)){

				$version = mysql_fetch_assoc($r);

				$version = $version['option_value'];

			}
			else{

				return array('status'=>false, 'information'=>'Your database appears to be corrupt or in a non-standard and unsupported format.');

			}

		}

		if($version == 0){

			//Version will equal "0" for any version below 1.3.4
			//We need to update the config table
			$r = mysql_query('SELECT * FROM config');

			if(@mysql_num_rows($r)){

				$config = mysql_fetch_assoc($r);

				mysql_query('DROP TABLE IF EXISTS config');

				$sql = "CREATE TABLE IF NOT EXISTS config (
						 config_id bigint(20) unsigned NOT NULL auto_increment,
						 site_id int(11) NOT NULL default '0',
						 option_name varchar(64) character set utf8 collate utf8_bin NOT NULL,
						 option_value longtext character set utf8 collate utf8_bin,
						 autoload tinyint(1) NOT NULL default '1',
						PRIMARY KEY (config_id,site_id,option_name),
						UNIQUE KEY option_name (option_name)
						) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";

				if(mysql_query($sql)){

					foreach($config as $k=>$v){

						if($k == 'version'){

							$v = ADP_VER;

						}

						mysql_query('INSERT INTO config (option_name, option_value) VALUES ("' . mysql_real_escape_string($k) . '", "' . mysql_real_escape_string($v) . '")');

					}

					//Insert version check value
					mysql_query('INSERT INTO config (option_name, option_value) VALUES ("version_check", "' . mysql_real_escape_string(serialize(array('latest_version'=>ADP_VER, 'last_check'=>0))) . '")');

					//Fix potential eregi to preg_match bugs
					mysql_query('UPDATE config SET option_value = "/<a(\s*)href="http:\/\/(.*)geekcoders.com(.*)">([^\n]+)<\/a>/" WHERE option_name = "recip_regex" LIMIT 1');
					mysql_query('UPDATE config SET option_value = "/text/html/" WHERE option_name = "spider_ReceiveContentType" LIMIT 1');

					//Update the following tables to allow for maximum amount of entries
					mysql_query('ALTER TABLE links CHANGE id id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT');
					mysql_query('ALTER TABLE pages CHANGE id id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT');
					mysql_query('ALTER TABLE search_log CHANGE id id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT');

					return array('status'=>true);

				}
				else{

					return array('status'=>false, 'information'=>'I could not create the config table. You may need to restore from a backup.');

				}

			}
			else{

				return array('status'=>false, 'information'=>'Your database appears to be corrupt or in a non-standard and unsupported format.');

			}

		}
		elseif(version_compare(ADP_VER, $version, '>')){

			if(version_compare('1.3.6', $version, '==')){

				mysql_query('UPDATE config SET option_value = "' . mysql_real_escape_string(ADP_VER) . '" WHERE option_name = "version" LIMIT 1');
				mysql_query('UPDATE config SET option_value = "/<a(\s*)href="http:\/\/(.*)' . mysql_real_escape_string($_SERVER['SERVER_NAME']) . '(.*)">([^\n]+)<\/a>/" WHERE option_name = "recip_regex" LIMIT 1');
				mysql_query('UPDATE config SET option_value = "/text/html/" WHERE option_name = "spider_ReceiveContentType" LIMIT 1');

				mysql_query('REPLACE INTO config (option_name, option_value) VALUES ("version_check", "' . mysql_real_escape_string(serialize(array('latest_version'=>ADP_VER, 'last_check'=>0))) . '")');

			}
			elseif(version_compare('1.3.5', $version, '>')){

				//Update the following tables to allow for maximum amount of entries
				mysql_query('ALTER TABLE links CHANGE id id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT');
				mysql_query('ALTER TABLE pages CHANGE id id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT');
				mysql_query('ALTER TABLE search_log CHANGE id id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT');

			}
			else{

				//latest version
				mysql_query('UPDATE config SET option_value = "' . mysql_real_escape_string(ADP_VER) . '" WHERE option_name = "version" LIMIT 1');

			}

			return array('status'=>true);

		}

	}

	return array('status'=>false, 'information'=>'Your ADP appears to be up to date.');

}

?>